# -*- coding: UTF-8 -*-

import types
import MySQLdb
import MySQLdb.cursors
from MySQLdb.constants import FIELD_TYPE
from MySQLdb.converters import conversions
from _mysql import escape_sequence
from distutils.version import StrictVersion

# MySQLdb не совсем корректно работает с массивами и кортежами, когда их передаешь, чтобы подставить в запрос " value IN %s "
# значения, которые есть в кортеже оборачиваются дополнитьльно в кавычки, поэтому запрос отрабатывает не так как ожидалось
# Например, ожидали " value IN ('a', 'b', 'c') ", а получаем " value IN ("'a'", "'b'", "'c'") "
# Поэтому дописан такой конвертер, который изначальный кортеж со всеми переданными параметрами в запрос обрабатывает стандартно,
# а вложенные кортежи с помощью метода skipTuple

def skipTuple(s, d):
    return "('%s')" % "','".join(s)

def tupleToStr(s, d):
    d[types.TupleType] = skipTuple
    t = escape_sequence(s, d)
    d[types.TupleType] = tupleToStr
    return t

def bitToInt(s):
    return ord(s) if s else 0

def connect(host = 'localhost', port=3306, user='netroot', passwd='netroot', db='documentsAll'):
    # на разных версиях библиотеки MySQLdb требуются разные конвертеры
    replaceFunction = tupleToStr if StrictVersion(MySQLdb.__version__) < StrictVersion('1.3.10') else skipTuple
    conversions[types.TupleType] = replaceFunction
    conversions[types.ListType] = replaceFunction
    conversions[FIELD_TYPE.BIT] = bitToInt
    connection = MySQLdb.connect(host=host, port=port, user=user, passwd=passwd, db=db, cursorclass=MySQLdb.cursors.DictCursor, conv=conversions)
    connection.set_character_set('utf8')
    return connection